--         -----------------------------------------------------------------------
--        |  TinyMeleeStats by TheVaan                                            |
--        |  based on TinyMeleeStats by Sideshow (Draenor EU)   |
--         -----------------------------------------------------------------------

local L = LibStub("AceLocale-3.0"):GetLocale("TinyMeleeStats")

function TMS_OnLoad()
	TinyMeleeStats = {
		['Font'] = "Vera";
		['Size'] = 10;
		['Style'] = 1;
		['FrameMoveable'] = 1;
		['Action'] = true;
		['yPosition'] = 200;
		['xPosition'] = 200;
		['Vis'] = 0.3;
	}
end

function TMS_config(msg)
    local cmds
    if msg == "" then
		configwk = L["|cffffd700~TinyMeleeStats~\nKonfigurationsbefehle:\n|c00ff00ff/tms\n    |c001E90FFfont |cff00ff00[|rbera|cff00ff00|||rlucida|cff00ff00|||rteen|cff00ff00|||rbaarsophia|cff00ff00]|cffffd700 Schriftart wechseln\n    |c001E90FFlock |cff00ff00[|ron|cff00ff00|||roff|cff00ff00]|cffffd700 Text fixieren/freistellen|r"]
        DEFAULT_CHAT_FRAME:AddMessage(configwk);
    else
		local tCmds, sCmd = {}

		for sCmd in string.gmatch(msg,"%w+") do
			table.insert(tCmds,string.lower(sCmd))
		end
		if (tCmds[1] == "font") then
			configfont = L["|cffffd700Um die nderung zu bernehmen musst du das Interface neuladen. Dies geht mit /tms reload|r"]
			configfontmissed = L["|cffff6060Keine g\195\188ltige Eingabe!\n|c00ff00ff/tms |c001E90FFfont |cff00ff00[|rbera|cff00ff00|||rlucida|cff00ff00|||rteen|cff00ff00|||rbaarsophia|cff00ff00]|cffffd700 \195\132ndert die Schriftart|r"]
			if (tCmds[2] == "vera") then
				TinyMeleeStats.Font = "Vera";
				DEFAULT_CHAT_FRAME:AddMessage(configfont);
			elseif (tCmds[2] == "teen") then
				TinyMeleeStats.Font = "Teen";
				DEFAULT_CHAT_FRAME:AddMessage(configfont);
			elseif (tCmds[2] == "lucida") then
				TinyMeleeStats.Font = "LucidaSD";
				DEFAULT_CHAT_FRAME:AddMessage(configfont);
			elseif (tCmds[2] == "baarsophia") then
				TinyMeleeStats.Font = "BaarSophia";
				DEFAULT_CHAT_FRAME:AddMessage(configfont);
			else
				DEFAULT_CHAT_FRAME:AddMessage(configfontmissed);
			end
			--tmsstr:SetFont("Fonts\\"..TinyMeleeStats.Font..".ttf", TinyMeleeStats.Size, "OUTLINE");
		elseif (tCmds[1] == "lock") then
			if (tCmds[2] == "on") then
				configlockon = L["|cffffd700Die Textzeile ist jetzt fixiert!|r"]
				TinyMeleeStats.FrameMoveable = 0;
				tmsframe:SetMovable(0);
				DEFAULT_CHAT_FRAME:AddMessage(configlockon);
			elseif (tCmds[2] == "off") then
				configlockoff = L["|cffffd700Die Textzeile ist jetzt freigegeben!|r"]
				TinyMeleeStats.FrameMoveable = 1;
				tmsframe:SetMovable(1);
				DEFAULT_CHAT_FRAME:AddMessage(configlockoff);
			else
				configlockmissed = 
				DEFAULT_CHAT_FRAME:AddMessage(configlockmissed);
			end
		elseif (tCmds[1] == "vis") then
			TinyMeleeStats.Vis = ((tCmds[2])/100);
			if (TinyMeleeStats.Vis <= 0) then
				TinyMeleeStats.Vis = 0;
			end
			configvis = L["|cffffd700Sichtbarkeit auerhalb des Kampfes:"]
			DEFAULT_CHAT_FRAME:AddMessage(configvis.." "..tCmds[2].."%|r");
		elseif (tCmds[1] == "reload") then
			ReloadUI();		
		else
			configerror = L["|cffff6060Keine g\195\188ltige Eingabe!\nKonfigurationsbefehle:\n|c00ff00ff/tms\n    |c001E90FFfont |cff00ff00[|rSchriftart|cff00ff00]|cffffd700 Schriftart wechseln\n    |c001E90FFlock |cff00ff00[on|off]|cffffd700 Text fixieren/freistellen|r"]
			DEFAULT_CHAT_FRAME:AddMessage(configerror);
		end
    end
end

SlashCmdList["TMS"] = TMS_config;
SLASH_TMS1 = "/tms";

local tmsframe = CreateFrame("Frame","tmsframe",UIParent)
tmsframe:SetWidth(100);
tmsframe:SetHeight(15);
tmsframe:EnableMouse(1);
tmsframe:EnableMouseWheel(1);
tmsframe:SetFrameStrata("BACKGROUND");

tmsframe:RegisterEvent("PLAYER_ENTERING_WORLD");
tmsframe:RegisterEvent("ADDON_LOADED");
tmsframe:RegisterEvent("VARIABLES_LOADED");
tmsframe:RegisterEvent("UNIT_ATTACK_POWER");
tmsframe:RegisterEvent("UNIT_ATTACK_SPEED");
tmsframe:RegisterEvent("UNIT_AURA");
tmsframe:RegisterEvent("UPDATE_SHAPESHIFT_FORMS");
tmsframe:RegisterEvent("UNIT_INVENTORY_CHANGED");
tmsframe:RegisterEvent("UNIT_LEVEL");
tmsframe:RegisterEvent("PLAYER_REGEN_ENABLED");
tmsframe:RegisterEvent("PLAYER_REGEN_DISABLED");

tmsframe:SetScript("OnEvent", function() TMS_OnEvent(event, arg1) end);
tmsframe:SetScript("OnUpdate", function() TMS_OnEvent(event, arg1) end);
tmsframe:RegisterForDrag("LeftButton");
tmsframe:SetScript("OnMouseWheel", function() TMS_changestyle(arg1) end);
 
local tmsstr = tmsframe:CreateFontString();
tmsstr:SetFontObject(GameFontNormal);
tmsstr:SetPoint("CENTER", tmsframe);
tmsstr:SetJustifyH("CENTER");
tmsstr:SetJustifyV("MIDDLE");
--tmsstr:SetFont("Fonts\\"..TinyMeleeStats.Font..".ttf", TinyMeleeStats.Size, "OUTLINE");

addonloaded = L["|cffffd700TinyMeleeStats:\nMit |c00ff00ff/tms|cffffd700 kommst du ins Konfigurationsmen\195\188|r"]
DEFAULT_CHAT_FRAME:AddMessage(addonloaded);

function TMS_OnEvent(event, arg1)
	if (event == "ADDON_LOADED") then
		tmsframe:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", TinyMeleeStats.xPosition, TinyMeleeStats.yPosition);
	end
	if (TinyMeleeStats.FrameMoveable == 1) then 
		tmsframe:SetScript("OnDragStart", function() tmsframe:StartMoving() end);
		tmsframe:SetScript("OnDragStop", function() tmsframe:StopMovingOrSizing() TinyMeleeStats.xPosition = tmsframe:GetLeft() TinyMeleeStats.yPosition = tmsframe:GetBottom() end);-- TinyMeleeStats.xPosition = tmsframe:GetLeft() TinyMeleeStats.yPosition = tmsframe:GetTop()
	elseif  (TinyMeleeStats.FrameMoveable == 0) then
		fixed = L["|cffFF0000Der Text ist fixiert. Freigeben mit |c00ff00ff/tms |c001E90FFlock |cff00ff00off|cffFF0000!"]
		tmsframe:SetScript("OnDragStart", function() DEFAULT_CHAT_FRAME:AddMessage(fixed) end);
	end
	if ((event == "PLAYER_REGEN_ENABLED") or (event == "PLAYER_ENTERING_WORLD")) then
		tmsframe:SetAlpha(TinyMeleeStats.Vis);
	end
	if (event == "PLAYER_REGEN_DISABLED") then
		tmsframe:SetAlpha(1);
	end
	if (event == "VARIABLES_LOADED") then
		if(not TinyMeleeStats.Font) then TinyMeleeStats.Font = "Vera" end;
		if(not TinyMeleeStats.Size) then TinyMeleeStats.Size = 10 end;
		if(not TinyMeleeStats.Style) then TinyMeleeStats.Style = 1 end;
		if(not TinyMeleeStats.FrameMoveable) then TinyMeleeStats.FrameMoveable = 1 end;
		if(not TinyMeleeStats.xPosition) then TinyMeleeStats.xPosition = 200 end;
		if(not TinyMeleeStats.yPosition) then TinyMeleeStats.yPosition = 200 end;
		if(not TinyMeleeStats.Vis) then TinyMeleeStats.Vis = 0.3 end;
  	end
	if (TinyMeleeStats.FrameMoveable == 1) then 
		tmsframe:SetMovable(1);
	elseif (TinyMeleeStats.FrameMoveable == 0) then 
		tmsframe:SetMovable(0);
	end
  	TMS_stats();
end

function TMS_stats()
	if ((event == "UNIT_ATTACK_POWER") or (event == "UNIT_ATTACK_SPEED") or (event == "UNIT_STATS") or (event == "UNIT_AURA") or (TinyMeleeStats.Action == true) or (event == "PLAYER_ENTERING_WORLD")) then
		if (TinyMeleeStats.Style == 1) then
			mainSpeed, offSpeed = UnitAttackSpeed("player");
			base, buff, debuff = UnitAttackPower("player");
			pow = base + buff + debuff;
			if(offSpeed == nil) then
				tmsstr:SetText("|c00ffef00"..pow.."|r |c00ff00ff"..string.format("%.2f", GetCritChance("player")).."|r |c001E90FF"..string.format("%.2f", mainSpeed).."|r");
			else
				tmsstr:SetText("|c00ffef00"..pow.."|r |c00ff00ff"..string.format("%.2f", GetCritChance("player")).."|r |c001E90FF"..string.format("%.2f", mainSpeed).." "..string.format("%.2f", offSpeed).."|r");
			end
			TinyMeleeStats.Action = false;
		elseif (TinyMeleeStats.Style == 2) then
			base, buff, debuff = UnitAttackPower("player");
			pow = base + buff + debuff;
			tmsstr:SetText("|c00ffef00"..pow.."|r");
		elseif (TinyMeleeStats.Style == 3) then
			base, buff, debuff = UnitAttackPower("player");
			pow = base + buff + debuff;
			tmsstr:SetText("|c00ffef00"..pow.."|r |c00ff00ff"..string.format("%.2f", GetCritChance("player")).."|r");
			TinyMeleeStats.Action = false;
		elseif (TinyMeleeStats.Style == 4) then
			tmsstr:SetText("|c00ff00ff"..string.format("%.2f", GetCritChance("player")).."|r");
			TinyMeleeStats.Action = false;
		elseif (TinyMeleeStats.Style == 5) then
			mainSpeed, offSpeed = UnitAttackSpeed("player");
			if(offSpeed == nil) then
				tmsstr:SetText("|c001E90FF"..string.format("%.2f", mainSpeed).."|r");
			else
				tmsstr:SetText("|c001E90FF"..string.format("%.2f", mainSpeed).." "..string.format("%.2f", offSpeed).."|r");
			end
			TinyMeleeStats.Action = false;
		end
	end
end

function TMS_changestyle(arg1)
	if (arg1 == 1) then
		TinyMeleeStats.Style = TinyMeleeStats.Style + 1;
		if (TinyMeleeStats.Style > 5) then
			TinyMeleeStats.Style = 5;
		end
		TinyMeleeStats.Action = true;
	else
		TinyMeleeStats.Style = TinyMeleeStats.Style - 1;
		if (TinyMeleeStats.Style < 1) then
			TinyMeleeStats.Style = 1;
		end
		TinyMeleeStats.Action = true;
	end
end
